import Model

extension Piece: Codable {
    public init(from decoder: any Decoder) throws {
        let player = (try CodablePlayerReferenceWrapper.init(from: decoder)).player
        self = Self.init(owner: player)
    }
    
    public func encode(to encoder: any Encoder) throws {
        try CodablePlayerReferenceWrapper(of: self.owner).encode(to: encoder)
    }
}

extension PieceType: CodingKey { }
